#ifndef MATH_OPS_GROUP
#define MATH_OPS_GROUP

/*****************************************************************************\
*                                                                             *
*  Name   : mathematical operations                                           *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2002-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

/*! file math_ops.h
  @brief A grab-bag of commonly useful mathematical functions.
*/

#include "mathematics_dll.h"

namespace mathematics {

int MATHEMATICS_FUNCTION_STYLE round_it(float to_round);
  //!< returns the rounded integer value for "to_round".
int MATHEMATICS_FUNCTION_STYLE round_it(double to_round);
  //!< returns the rounded integer value for "to_round".

u_int MATHEMATICS_FUNCTION_STYLE pow_2(const u_int raise_to);
  //!< returns the number two to the power "raise_to" (i.e. 2^raise_to).

} // namespace

#endif

