#ifndef MATHEMATICS_DLL_HELPER
#define MATHEMATICS_DLL_HELPER

/*****************************************************************************\
*                                                                             *
*  Name   : mathematics dll header                                            *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2002-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

/*! file mathematics_dll.h
  @brief Allows the mathematics library to live in a DLL.
*/

#include <basis/build_configuration.h>

// define BUILD_MATHEMATICS when you are creating the mathematics dll and
// define USE_HOOPLE_DLLS when you are importing a class from the dll.

#if defined(BUILD_MATHEMATICS)
  #define MATHEMATICS_CLASS_STYLE    HOOPLE_DLL_EXPORT_CLASS
  #define MATHEMATICS_FUNCTION_STYLE HOOPLE_DLL_EXPORT_FUNCTION
#elif defined(USE_HOOPLE_DLLS)
  #define MATHEMATICS_CLASS_STYLE    HOOPLE_DLL_IMPORT_CLASS
  #define MATHEMATICS_FUNCTION_STYLE HOOPLE_DLL_IMPORT_FUNCTION
#else
  #define MATHEMATICS_CLASS_STYLE
  #define MATHEMATICS_FUNCTION_STYLE
#endif

#endif

