#ifndef MECHANISMS_DLL_HELPER
#define MECHANISMS_DLL_HELPER

/*****************************************************************************\
*                                                                             *
*  Name   : mechanisms dll header                                             *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1995-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include <basis/build_configuration.h>

/*!
  @file mechanisms_dll.h
  @brief Allows the mechanisms library to live in a DLL.
*/

// define BUILD_MECHANISMS when you are creating the mechanisms dll and
// define USE_HOOPLE_DLLS when you are importing a class from the dll.

#if defined(BUILD_MECHANISMS)
  #define MECHANISMS_CLASS_STYLE    HOOPLE_DLL_EXPORT_CLASS
  #define MECHANISMS_FUNCTION_STYLE HOOPLE_DLL_EXPORT_FUNCTION
#elif defined(USE_HOOPLE_DLLS)
  #define MECHANISMS_CLASS_STYLE    HOOPLE_DLL_IMPORT_CLASS
  #define MECHANISMS_FUNCTION_STYLE HOOPLE_DLL_IMPORT_FUNCTION
#else
  #define MECHANISMS_CLASS_STYLE
  #define MECHANISMS_FUNCTION_STYLE
#endif

#endif

