#ifndef IMPLEMENTATION_ONLY_SUPPORT
#define IMPLEMENTATION_ONLY_SUPPORT

/*****************************************************************************\
*                                                                             *
*  Name   : mechanisms implementation support                                 *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1995-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include <basis/log_base.h>
#include <basis/utility.h>

/*!
  @file mechanisms_implementation_only.h
  This code is used only by implementation files in this library.  Thus it
  should not affect the interface of the library when this file is changed.
*/

#define DEBUG_MECHANISMS
  // turn this flag on for a debugging version of the mechanisms library.
  // individual classes can turn this back on by defining it before including
  // this file.

#undef LOG
#ifdef DEBUG_MECHANISMS
  #define LOG(to_print) CLASS_EMERGENCY_LOG(program_wide_logger(), to_print)
#else
  #define LOG(s) {}
#endif

#endif

