//note: in progress.

/*****************************************************************************\
*                                                                             *
*  Name   : menu_base                                                         *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2003-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "menu_base.h"

#include <basis/common_templates.h>
#include <basis/utility.h>
#include <data_struct/amorph.cpp>

class menu_common_amorph : public amorph<menu_common_base>
{
};

////////////////////////////////////////////////////////////////////////////

menu_common_base::~menu_common_base() {}

////////////////////////////////////////////////////////////////////////////

menu_item::menu_item(const string_array &trigs,
    const istring &text, const istring &description)
: _triggers(new string_array(trigs)),
  _text(new istring(text)),
  _description(new istring(description))
{}

menu_item::menu_item(const menu_item &to_copy)
: _triggers(new string_array),
  _text(new istring),
  _description(new istring)
{ *this = to_copy; }

menu_item::~menu_item()
{
  WHACK(_text);
  WHACK(_description);
}

menu_item &menu_item::operator =(const menu_item &to_copy)
{
  if (this == &to_copy) return *this;
  *_triggers = *to_copy._triggers;
  *_text = *to_copy._text;
  *_description = *to_copy._description;
  return *this;
}

const string_array &menu_item::triggers() const { return *_triggers; }

const istring &menu_item::text() const { return *_text; }

const istring &menu_item::description() const { return *_description; }

////////////////////////////////////////////////////////////////////////////

//call this when menu invoked.
///  virtual bool menu_item_activity() = 0;

menu_base::menu_base(const istring &title, const menu_item &parameters)
: _title(new istring(title)),
  _parameters(new menu_item(parameters)),
  _items(new menu_common_amorph),
  _menus(new menu_common_amorph)
{
}

menu_base::~menu_base()
{
  WHACK(_title);
  WHACK(_menus);
  WHACK(_items);
}

bool menu_base::validate(bool recursive)
{
return false;
}

istring menu_base::text_form() const
{
return "";
}

istring menu_base::recursive_text_form() const
{
return "";
}

int menu_base::items() const
{
return 0;
}

void menu_base::add_item(menu_item *to_invoke)
{
}

menu_item *menu_base::get_item(int index)
{
return NIL;
}

bool menu_base::zap_item(int index)
{
return false;
}

bool menu_base::enable_item(int index, bool enable)
{
return false;
}

int menu_base::submenus() const
{
return 0;
}

void menu_base::add_submenu(menu_base *sub)
{
}

menu_base *menu_base::get_submenu(int index)
{
return NIL;
}

bool menu_base::zap_submenu(int index)
{
return false;
}

bool menu_base::enable_submenu(int index, bool enable)
{
return false;
}

menu_common_base *menu_base::evaluate_trigger(char trigger)
{
return NIL;
}

void menu_base::activate()
{
}

