/*****************************************************************************\
*                                                                             *
*  Name   : roller                                                            *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1996-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "roller.h"

#ifndef ROLLER_CLASS_IMPLEMENTATION
#define ROLLER_CLASS_IMPLEMENTATION

template <class contents>
roller<contents>::roller(contents start, contents end)
: _current_id(start), _start_of_range(start), _end_of_range(end) {}

template <class contents>
void roller<contents>::set_current(contents new_current)
{
  _current_id = new_current;
  if (_current_id >= _end_of_range) _current_id = _start_of_range;
}

template <class contents> roller<contents>::~roller() {}

template <class contents> contents roller<contents>::current() const
{ return _current_id; }

template <class contents> contents roller<contents>::next_id()
{
  contents to_return = _current_id;
  if (to_return == _end_of_range) {
    // somehow the id to return is at the end of the range.  this probably
    // means the end of range condition wasn't detected last time due to an
    // error in the parameters or the operation of == or ++ in the templated
    // class.
    _current_id = _start_of_range;
    to_return = _current_id;
  }
  _current_id++;  // next id.
  if (_current_id == _end_of_range) _current_id = _start_of_range;
    // reset the current position when hits the end of the range.
  return to_return;
}

#endif

