#ifndef HAMMING_DLL_GROUP
#define HAMMING_DLL_GROUP

/*****************************************************************************\
*                                                                             *
*  Name   : hamming library dll header                                        *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*  Purpose:                                                                   *
*                                                                             *
*    Provides macros for dealing with win32 dynamic libraries.                *
*                                                                             *
*******************************************************************************
* Copyright (c) 2005-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include <basis/build_configuration.h>

// define BUILD_HAMMING when you are creating the dll and
// define USE_HOOPLE_DLLS when you are importing a class from the dll.

#ifdef BUILD_HAMMING
  #define HAMMING_CLASS_STYLE    HOOPLE_DLL_EXPORT_CLASS
  #define HAMMING_FUNCTION_STYLE HOOPLE_DLL_EXPORT_FUNCTION
#elif defined(USE_HOOPLE_DLLS)
  #define HAMMING_CLASS_STYLE    HOOPLE_DLL_IMPORT_CLASS
  #define HAMMING_FUNCTION_STYLE HOOPLE_DLL_IMPORT_FUNCTION
#else
  #define HAMMING_CLASS_STYLE
  #define HAMMING_FUNCTION_STYLE
#endif

#endif

