/*****************************************************************************\
*                                                                             *
*  Name   : filename_tree                                                     *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2004-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "filename_tree.h"

using namespace basis;
using namespace nodes;

filename_tree::filename_tree() : _depth(0) {}

filename_tree::~filename_tree() { _dirname = ""; _files.reset(); }

void filename_tree::pack(byte_array &packed_form) const {
  basis::attach(packed_form, _depth);
  _dirname.pack(packed_form);
  _files.pack(packed_form);
}

bool filename_tree::unpack(byte_array &packed_form) {
  if (!basis::detach(packed_form, _depth)) return false;
  if (!_dirname.unpack(packed_form)) return false;
  if (!_files.unpack(packed_form)) return false;
  return true;
}

