#ifndef FILENAME_TREE_CLASS
#define FILENAME_TREE_CLASS

/*****************************************************************************\
*                                                                             *
*  Name   : filename_tree                                                     *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 2004-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

//! This is a support class for the directory_tree.
/*!
  This class has been exported from directory_tree's implementation to
  avoid redundant code for iteration and such.
  Note: this is a heavy-weight header that should not be included in other
  headers.
*/

#include "filename_list.h"

#include <nodes/packable_tree.h>

class OPSYSTEM_CLASS_STYLE filename_tree : public nodes::packable_tree
{
public:
  filename _dirname;  //!< the full directory name at this position.
  filename_list _files;  //!< the filenames that are at this node in the tree.
  int _depth;  //!< how far below root node are we.

  filename_tree();

  virtual ~filename_tree();

  virtual void pack(byte_array &packed_form) const;

  virtual bool unpack(byte_array &packed_form);
};

//! this is the creator method used in the recursive_unpack.
class OPSYSTEM_CLASS_STYLE fname_tree_creator
: public nodes::packable_tree_factory
{
public:
  virtual nodes::packable_tree *create() { return new filename_tree; }
};

#endif

