#ifndef OPERATING_SYSTEMS_DLL_GROUP
#define OPERATING_SYSTEMS_DLL_GROUP

/*****************************************************************************\
*                                                                             *
*  Name   : operating systems library dll header                              *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*  Purpose:                                                                   *
*                                                                             *
*    Provides macros for dealing with dynamic libraries.                      *
*                                                                             *
*******************************************************************************
* Copyright (c) 2000-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include <basis/build_configuration.h>

// define BUILD_OPERATING_SYSTEM when you are creating the dll and
// define USE_HOOPLE_DLLS when you are importing a class from the dll.

#ifdef BUILD_OPERATING_SYSTEM
  #define OPSYSTEM_CLASS_STYLE    HOOPLE_DLL_EXPORT_CLASS
  #define OPSYSTEM_FUNCTION_STYLE HOOPLE_DLL_EXPORT_FUNCTION
#elif defined(USE_HOOPLE_DLLS)
  #define OPSYSTEM_CLASS_STYLE    HOOPLE_DLL_IMPORT_CLASS
  #define OPSYSTEM_FUNCTION_STYLE HOOPLE_DLL_IMPORT_FUNCTION
#else
  #define OPSYSTEM_CLASS_STYLE
  #define OPSYSTEM_FUNCTION_STYLE
#endif

#endif

