#ifndef OS_EVENT_CLASS
#define OS_EVENT_CLASS

/*****************************************************************************\
*                                                                             *
*  Name   : OS_event                                                          *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*  Purpose:                                                                   *
*                                                                             *
*    Models an OS-level event so we can talk about things going on in the     *
*  external environment.                                                      *
*                                                                             *
*******************************************************************************
* Copyright (c) 1995-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "letter.h"

// forward.
class post_office;

class POST_OFFICE_CLASS_STYLE OS_event : public letter
{
public:
  u_int _message;
  u_int _parm1;
  u_int _parm2;

  OS_event(int event_type, u_int message, u_int parm1, u_int parm2)
  : letter(event_type), _message(message), _parm1(parm1), _parm2(parm2) {}

  virtual istring text_form() const;
};

#endif

