/*****************************************************************************\
*                                                                             *
*  Name   : schedulable                                                       *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*******************************************************************************
* Copyright (c) 1991-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include "schedulable.h"

#include <basis/istring.h>
#include <mathematics/averager.cpp>

schedulable::schedulable(const scheduling_id &item_id, int actor_id,
    const periodicity &when_to_schedule)
: periodicity(when_to_schedule),
  _actor_id(actor_id),
  _sched_id(item_id),
  _stats(),
  _expiration_timer(1, when_to_schedule.expiration_interval),
  _preprocessed(false)
{}

schedulable::~schedulable() {}

istring schedulable::schedulable_text_form() const
{
  return istring(istring::SPRINTF, "schedulable[%d] with period [",
        _sched_id.raw_id())
      + periodicity::per_text_form()
      + istring(istring::SPRINTF, "], actor id of %d, heartbeat "
            "left %dms, stats: ", _actor_id, _expiration_timer.time_left())
      + _stats.text_form();
}

