#ifndef SCHEDULING_DLL_DEFINITIONS
#define SCHEDULING_DLL_DEFINITIONS

/*****************************************************************************\
*                                                                             *
*  Name   : scheduling DLL helper                                             *
*  Author : Chris Koeritz                                                     *
*                                                                             *
*  Purpose:                                                                   *
*                                                                             *
*    Allows the library to work within a DLL.                                 *
*                                                                             *
*******************************************************************************
* Copyright (c) 1995-$now By Author.  This program is free software; you can  *
* redistribute it and/or modify it under the terms of the GNU General Public  *
* License as published by the Free Software Foundation; either version 2 of   *
* the License or (at your option) any later version.  This is online at:      *
*     http://www.fsf.org/copyleft/gpl.html                                    *
* Please send any updates to: fred@gruntose.com                               *
\*****************************************************************************/

#include <basis/build_configuration.h>

// define BUILD_SCHEDULING when you are creating the dll and
// define USE_HOOPLE_DLLS when you are importing a class from the dll.
#if defined(BUILD_SCHEDULING)
  #define SCHEDULING_CLASS_STYLE    HOOPLE_DLL_EXPORT_CLASS
  #define SCHEDULING_FUNCTION_STYLE HOOPLE_DLL_EXPORT_FUNCTION
#elif defined(USE_HOOPLE_DLLS)
  #define SCHEDULING_CLASS_STYLE    HOOPLE_DLL_IMPORT_CLASS
  #define SCHEDULING_FUNCTION_STYLE HOOPLE_DLL_IMPORT_FUNCTION
#else
  #define SCHEDULING_CLASS_STYLE
  #define SCHEDULING_FUNCTION_STYLE
#endif

#endif

